ValueAggregatorReducer (Apache Hadoop Main 3.5.0 API)
Description: declaration: package: org.apache.hadoop.mapred.lib.aggregate, class: ValueAggregatorReducer

Package org.apache.hadoop.mapred.lib.aggregate

# Class ValueAggregatorReducer<K1 extends WritableComparable,V1 extends Writable>

java.lang.Object
org.apache.hadoop.mapred.lib.aggregate.ValueAggregatorJobBase<K1,V1>
org.apache.hadoop.mapred.lib.aggregate.ValueAggregatorReducer<K1,V1>

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Closeable`, `JobConfigurable`, `Mapper<K1,V1,Text,Text>`, `Reducer<Text,Text,Text,Text>`

@Public @Stable public class ValueAggregatorReducer<K1 extends WritableComparable,V1 extends Writable> extends ValueAggregatorJobBase<K1,V1>
This class implements the generic reducer of Aggregate.

- ## Field Summary

  ### Fields inherited from class org.apache.hadoop.mapred.lib.aggregate.ValueAggregatorJobBase

  `aggregatorDescriptorList`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ValueAggregatorReducer()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `map(K1 arg0, V1 arg1, OutputCollector<Text,Text> arg2, Reporter arg3)`
  Do nothing.
  `void`
  `reduce(Text key, Iterator<Text> values, OutputCollector<Text,Text> output, Reporter reporter)`
  Reduces values for a given key.

  ### Methods inherited from class org.apache.hadoop.mapred.lib.aggregate.ValueAggregatorJobBase

  `close, configure, logSpec`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ValueAggregatorReducer

    public ValueAggregatorReducer()

- ## Method Details

  - ### reduce

    public void reduce(Text key, Iterator<Text> values, OutputCollector<Text,Text> output, Reporter reporter) throws IOException
    Description copied from interface: `Reducer`
    Reduces values for a given key.

    The framework calls this method for each `<key, (list of values)>` pair in the grouped inputs. Output values must be of the same type as input values. Input keys must not be altered. The framework will reuse the key and value objects that are passed into the reduce, therefore the application should clone the objects they want to keep a copy of. In many cases, all values are combined into zero or one value.

    Output pairs are collected with calls to `OutputCollector.collect(Object,Object)`.

    Applications can use the `Reporter` provided to report progress or just indicate that they are alive. In scenarios where the application takes a significant amount of time to process individual key/value pairs, this is crucial since the framework might assume that the task has timed-out and kill that task. The other way of avoiding this is to set mapreduce.task.timeout to a high-enough value (or even zero for no time-outs).

    Parameters:
      `key` - the key is expected to be a Text object, whose prefix indicates the type of aggregation to aggregate the values. In effect, data driven computing is achieved. It is assumed that each aggregator's getReport method emits appropriate output for the aggregator. This may be further customiized.
      `values` - the values to be aggregated
      `output` - to collect keys and combined values.
      `reporter` - facility to report progress.
    Throws:
      `IOException`

  - ### map

    public void map(K1 arg0, V1 arg1, OutputCollector<Text,Text> arg2, Reporter arg3) throws IOException
    Do nothing. Should not be called
    Parameters:
      `arg0` - the input key.
      `arg1` - the input value.
      `arg2` - collects mapped keys and values.
      `arg3` - facility to report progress.
    Throws:
      `IOException`